var mobileUser_Phone="",
    mobileUser_NewsOptin="",
    mobileUser_Name="",
    mobileUser_Address="",
    mobileUser_Email="",
    mobileUser_Password="",
    mobileUser_Password_="",
    mobileUser_FavouriteFuel="",
    mobileUser_Car = [],
	mobileUser_NewsOptin="",
	editingCarIndex = null;

var sqlCreateUserTable = 'CREATE TABLE IF NOT EXISTS USER (logged, skipped, mobileUser_Name, mobileUser_Address, mobileUser_Email, mobileUser_Phone, mobileUser_Password, mobileUser_NewsOptin)';
console.log(sqlCreateUserTable);

function epicoInput(e) {

    if ($(this).data("epico-mask") /*&& $("body.ios").length < 1*/) {

        var value = String.fromCharCode(e.which),
            actualLen = $(this).val().length,
            inputValue = $(this).val(),
            reg = /[0-9 .]+/,
            regnumber = /[0-9,.]+/,
            regmail = /^[a-zA-Z0-9_.+-]+@[a-zA-Z0-9-]+\.[a-zA-Z0-9-.]+$/;

        if ( $(this).data("epico-mask") ) {
        	var maxlen = $(this).data("epico-mask").toString().length;
        	var maskValue = $(this).data("epico-mask").toString();
        	var actualMaskChar = maskValue.substr(actualLen, 1).toString();
        } else {
        	var maxlen = 999999;
        	var maskValue = "";
        	var actualMaskChar = "9"
        }

        if ( actualLen >= maxlen ) {
        	$(this).val( inputValue.replace(/[^0-9]+.,/, "") );
        	$(this).val( inputValue.substr(0, maxlen) );
        	$(e.target).nextAll('input, select').first().focus();
        	return false;
        }

        value = inputValue.substr(-1,1);


        if ( e.type == "keyup" ) {
            if ($(this).hasClass("iptNumber")) {
            	$(this).val( inputValue.replace(/[^0-9]+.,/, "") );
                if ( isNaN(actualMaskChar) && ( e.keyCode != 8 ) ) {
                	inputValue = $(this).val();
                	$(this).val(inputValue+actualMaskChar);
                }
            }
        }

    }

}

function epicoSubmitVerifier(e) {

    e.preventDefault();
    console.log('epicoSubmitVerifier')
    var $this = $(this),
        e = e,
        action = $this.data("action"),
        step = $this.data("step"),
        inputs = $('.form-submiter input');


    if (step == 4) {
        database(sqlCreateUserTable, function(result){
            if (result.error < 0) {

                database("SELECT * FROM USER", function(result){
                    userData = result.rows[0];
                    if(result.len > 0){
                        return;
                    }
                });

                database('INSERT INTO USER (skipped) VALUES (1)', function(result){
                    // CALLBACK
                    $.mobile.changePage(action, { transition: "fade" });
                });
            }
        });
    }



    var epicoFormTester = true,
	    reg = /[0-9 .]+/,
	    regmail = /^[a-zA-Z0-9_.+-]+@[a-zA-Z0-9-]+\.[a-zA-Z0-9-.]+$/;

    if (step == 4) {

    	epicoFormTester = true;

    } else {

    	$( inputs ).each(function( index ) {

        	var actualLen = $(this).val().length,
    	    	inputValue = $(this).val().toString();

        	if ( $(this).data("epico-mask") ) {
            	var maxlen = $(this).data("epico-mask").toString().length;
            	var maskValue = $(this).data("epico-mask").toString();
            	var actualMaskChar = maskValue.substr(actualLen, 1).toString();
            } else {
            	var maxlen = 999999;
            	var maskValue = "";
            	var actualMaskChar = "9";
            }

        	if ($(this).attr("required")) {

                if ($(this).hasClass("pass") && $(this).val().length < 4 ) {

                	$(this).removeClass("validated");
                    $(this).css("background", "#FFB8B8");

                } else if (actualLen < maskValue.replace("?","").length) {

                    $(this).removeClass("validated");
                    $(this).css("background", "#FFB8B8");

                } else {

                    $(this).addClass("validated");
                    $(this).css("background", "");

                }

            }

            var $thisInput = $( this );
            var required = $thisInput.attr("required") ? true : false;
            if (required && !$thisInput.hasClass("validated")) {
            	epicoFormTester = false;
            	$thisInput.css("background", "#FFB8B8");
            }

        });

        if ( $('#mobileUser_Email').length > 0 ) {

            //if( $('#mobileUser_Email').val().length > 0 ) {
                if (regmail.test( $('#mobileUser_Email').xval() ) ) {
                    $('#mobileUser_Email').css("background", "");
                } else {
                    window.plugins.toast.showShortCenter('O endereço de e-mail informado não é válido.', function(a){ }, function(b) { });
                    epicoFormTester = false;
                    $('#mobileUser_Email').css("background", "#FFB8B8");
                }
            //}

        }

        if ( $('#mobileUser_CEP').length > 0 ) {

            if ( $('#mobileUser_CEP').xval().length > 8 ) {
                $('#mobileUser_CEP').css("background", "");
            } else {
                window.plugins.toast.showShortCenter('O CEP é obrigatório.', function(a){ }, function(b) { });
                epicoFormTester = false;
                $('#mobileUser_CEP').css("background", "#FFB8B8");

            }

        }

        if ( $('#mobileUser_Name').length > 0 ) {

            if ( $('#mobileUser_Name').xval().length > 1 ) {
                $('#mobileUser_Name').css("background", "");
            } else {
                window.plugins.toast.showShortCenter('O Nome é obrigatório.', function(a){ }, function(b) { });
                epicoFormTester = false;
                $('#mobileUser_Name').css("background", "#FFB8B8");

            }

        }

    	if ( $('#mobileUser_Comp').length > 0 ) {

            if ( $('#mobileUser_Comp').xval().length > 0  ) {
                $('#mobileUser_Comp').css("background", "");
            } else {
                //window.plugins.toast.showShortCenter('O Complemento é obrigatório.', function(a){ }, function(b) { });
                epicoFormTester = false;
                $('#mobileUser_Comp').css("background", "#FFB8B8");
            }

        }

        if ( $('#denuncia').length > 0 ) {

        	$('#denuncia').css("background", "");
            if ( $('#denuncia').val().length == 0 ) {
                //window.plugins.toast.showShortCenter('O motivo da nenúncia é obrigatório.', function(a){ }, function(b) { });
                epicoFormTester = false;
                $('#denuncia').css("background", "#FFB8B8");

            }

        }

        if ( $('#mobileUserCar_Model').length > 0 ) {

        	$('#mobileUserCar_Model').parent().css("background-color", "");
        	$('#mobileUserCar_Year').parent().css("background-color", "");
        	$('#mobileUserCar_KMLGasoline').parent().css("background-color", "");
        	$('#mobileUserCar_KMLDiesel').parent().css("background-color", "");
        	$('#mobileUserCar_KMLAlcohol').parent().css("background-color", "");
        	$('#mobileUserCar_KMLCNG').parent().css("background-color", "");
        	$('#mobileUserCar_Maker').parent().css("background-color", "");
        	$('#mobileUserCar_TankSize').css("background-color", "");
        	$('#mobileUserCar_TankSize').css("background-color", "");
        	$('#mobileUser_FavoriteFuel').parent().css("background-color", "");

        	mobileUserCar_Maker = $('#mobileUserCar_Maker').find('option:selected').html();
            mobileUserCar_Model = $('#mobileUserCar_Model').find('option:selected').html();
            mobileUserCar_Year = $('#mobileUserCar_Year').find('option:selected').html();

            mobileUserCar_Name = $('#mobileUserCar_Name').xval();
            mobileUserCar_HasGasoline = Number($("input#mobileUserCar_HasGasoline")[0].checked);
            mobileUserCar_HasAlcohol = Number($("input#mobileUserCar_HasAlcohol")[0].checked);
            mobileUserCar_HasDiesel = Number($("input#mobileUserCar_HasDiesel")[0].checked);
            mobileUserCar_HasCNG = Number($("input#mobileUserCar_HasCNG")[0].checked);
            mobileUserCar_KMLGasoline = Number($('#mobileUserCar_KMLGasoline').xval());
            mobileUserCar_KMLDiesel = Number($('#mobileUserCar_KMLDiesel').xval());
            mobileUserCar_KMLAlcohol = Number($('#mobileUserCar_KMLAlcohol').xval());
            mobileUserCar_KMLCNG = Number($('#mobileUserCar_KMLCNG').xval());
            mobileUserCar_TankSize = Number($('#mobileUserCar_TankSize').xval());
            mobileUserCar_PrimaryFuel = $('#mobileUser_FavoriteFuel').val();

            if (mobileUserCar_Maker == "MARCA") {
            	$('#mobileUserCar_Maker').parent().css("background-color", "#FFB8B8");
            	epicoFormTester = false;
            }

            if ( ( mobileUserCar_Model == "MODELO" || mobileUserCar_Year == "ANO" ) ) {
                if (mobileUserCar_Model == "MODELO") $('#mobileUserCar_Model').parent().css("background-color", "#FFB8B8");
            	if (mobileUserCar_Year == "ANO") $('#mobileUserCar_Year').parent().css("background-color", "#FFB8B8");
                epicoFormTester = false;
            }

            if ( mobileUserCar_KMLGasoline == 0 && mobileUserCar_KMLDiesel == 0 && mobileUserCar_KMLAlcohol == 0 && mobileUserCar_KMLCNG == 0 ) {
            	//window.plugins.toast.showShortCenter('Escolha pelo menos um combustível para o veículo.', function(a){ }, function(b) { });
            	if ( mobileUserCar_HasGasoline > 0 && mobileUserCar_KMLGasoline == 0 ) $('#mobileUserCar_KMLGasoline').parent().css("background-color", "#FFB8B8");

            	if ( mobileUserCar_HasDiesel > 0 && mobileUserCar_KMLDiesel == 0 ) $('#mobileUserCar_KMLDiesel').parent().css("background-color", "#FFB8B8");

            	if ( mobileUserCar_HasAlcohol > 0 && mobileUserCar_KMLAlcohol == 0 ) $('#mobileUserCar_KMLAlcohol').parent().css("background-color", "#FFB8B8");

            	if ( mobileUserCar_HasCNG > 0 && mobileUserCar_KMLCNG == 0 ) $('#mobileUserCar_KMLCNG').parent().css("background-color", "#FFB8B8");

                epicoFormTester = false;
            }

            if ( mobileUserCar_TankSize == 0 ) {
            	//window.plugins.toast.showShortCenter('Marque a capacidade do tanque do veículo.', function(a){ }, function(b) { });
            	$('#mobileUserCar_TankSize').css("background-color", "#FFB8B8");
                epicoFormTester = false;
            }

            if ( mobileUserCar_PrimaryFuel == "COMBUSTÍVEL PREFERIDO" || mobileUserCar_PrimaryFuel == "" ) {
            	//window.plugins.toast.showShortCenter('Escolha o seu combustível favorito.', function(a){ }, function(b) { });
            	$('#mobileUser_FavoriteFuel').parent().css("background-color", "#FFB8B8");
                epicoFormTester = false;
            }

        }

        if ( $('#report_Subject').length > 0 ) {

        	$('#report_Subject').parent().css("background-color", "")

            if ( $('#report_Subject').val().length < 3 && $('#report_SubSubject').val().length < 3 ) {
                //window.plugins.toast.showShortCenter('Tanto o assunto quanto o subassunto são obrigatórios.', function(a){ }, function(b) { });
                epicoFormTester = false;

                if ( $('#report_Subject').val().length < 3 ) $('#report_Subject').parent().css("background-color", "#FFB8B8");

                //if ( $('#report_SubSubject').val().length < 3 ) $('#report_SubSubject').parent().css("background-color", "#FFB8B8");

            }

        }

    }





    if( !epicoFormTester ) {

        window.plugins.toast.showShortCenter('Informe os campos em vermelho corretamente.', function(a){ }, function(b) { });
    	return;

    } else {

        if (step == 1) {
            console.log('step 1')
            mobileUser_Phone = "55,"+$('#ddd').val()+","+$("#phone").val().replace("-","");
            mobileUser_NewsOptin = $("#mobileUser_NewsOptin")[0].checked;

            database(sqlCreateUserTable, function(result){
                if (result.error < 0) {

                    database("SELECT * FROM USER", function(result){
                        userData = result.rows[0];
                        if(result.len > 0){
                            database('DELETE FROM USER', function(result){
                                // CALLBACK
                                //$.mobile.changePage("edite-perfil.html", { transition: "fade" });
                            });
                            //return;
                        }
                    });

                    database('INSERT INTO USER (skipped) VALUES ("1")', function(result){
                        // CALLBACK
                        $.mobile.changePage(action, { transition: "fade" });
                    });
                }
            });

        } else if (step == 2) {

            mobileUser_Name = $("input#mobileUser_Name").val();
            mobileUser_Address = $("input#mobileUser_Address").val();
            mobileUser_Email = $("input#mobileUser_Email").val();
            mobileUser_Password = $("input#mobileUser_Password").val();
            mobileUser_Password_ = $("input#mobileUser_Password_").val();
            mobileUser_NewsOptin = Number($("input#mobileUser_NewsOptin")[0].checked);

            if (mobileUser_Password != mobileUser_Password_ || mobileUser_Password.length < 4) {
                window.plugins.toast.showShortCenter('As senhas não conferem.', function(a){ }, function(b) { });
                return;
            } else if (mobileUser_Email.length < 1) {
                window.plugins.toast.showShortCenter('E-mail Inválido.', function(a){ }, function(b) { });
                return;
            } else {
                //return false;
                $.mobile.changePage(action, { transition: "slide" });
            }

            /*var tmpSQL = 'UPDATE USER SET logged = 1, mobileUser_Name="'+mobileUser_Name+'", mobileUser_Address="'+mobileUser_Address+'", mobileUser_Email="'+mobileUser_Email+'", mobileUser_Password="'+mobileUser_Password+'", skipped=0';

            database(tmpSQL, function(result){

                if (result.error < 0) {
                    $.mobile.changePage(action, { transition: "fade" });
                }
            });*/

        } else if (step == 3) {

            /*mobileUserCar_Name = $("input#mobileUserCar_Name").val();
            mobileUserCar_HasGasoline = Number($("input#mobileUserCar_HasGasoline")[0].checked);
            mobileUserCar_HasAlcohol = Number($("input#mobileUserCar_HasAlcohol")[0].checked);
            mobileUserCar_HasDiesel = Number($("input#mobileUserCar_HasDiesel")[0].checked);
            mobileUserCar_HasCNG = Number($("input#mobileUserCar_HasCNG")[0].checked);

            mobileUserCar_KMLGasoline = $("#mobileUserCar_KMLGasoline").val();
            mobileUserCar_KMLAlcohol = $("#mobileUserCar_KMLAlcohol").val();
            mobileUserCar_KMLCNG = $("#mobileUserCar_KMLCNG").val();
            mobileUserCar_KMLDiesel = $("#mobileUserCar_KMLDiesel").val();

            mobileUserCar_TankSize = $("#mobileUserCar_TankSize").val();

            mobileUser_FavouriteFuel = $("#mobileUser_FavouriteFuel").val();*/

        	$('.ui-page-active').addClass("blurBoxes");
        	$.mobile.loading( 'show', {
                text: 'Enviando solicitação',
                textVisible: true,
                theme: 'c',
                html: "<p style=\"text-align:center\">Consultando servidores...</p>"
            });

            insertUserBackEnd(action);

            /*
             database('CREATE TABLE IF NOT EXISTS CARS (mobileUserCar_Maker,mobileUserCar_Model,mobileUserCar_Name,mobileUserCar_PrimaryFuel,mobileUserCar_HasGasoline,mobileUserCar_HasDiesel,mobileUserCar_HasAlcohol,mobileUserCar_HasCNG,mobileUserCar_KMLGasoline,mobileUserCar_KMLDiesel,mobileUserCar_KMLAlcohol,mobileUserCar_KMLCNG)', function(result){
                if (result.error < 0) {
                    database('INSERT INTO CARS (mobileUserCar_Name, mobileUserCar_HasGasoline, mobileUserCar_HasAlcohol, mobileUserCar_HasDiesel, mobileUserCar_HasCNG, mobileUserCar_KMLGasoline, mobileUserCar_KMLAlcohol, mobileUserCar_KMLCNG, mobileUserCar_KMLDiesel) VALUES ("'+mobileUserCar_Name+'", "'+mobileUserCar_HasGasoline+'", "'+mobileUserCar_HasAlcohol+'", "'+mobileUserCar_HasDiesel+'", "'+mobileUserCar_HasCNG+'", "'+mobileUserCar_KMLGasoline+'", "'+mobileUserCar_KMLAlcohol+'", "'+mobileUserCar_KMLCNG+'", "'+mobileUserCar_KMLDiesel+'")', function(result){
                        // CALLBACK



                        //$.mobile.changePage(action, { transition: "fade" });
                    });
                }
            });
            */
        } else if (step == 5) {
            verifyConnection(function(){
                $('.ui-page-active').addClass("blurBoxes");
                $.mobile.loading( 'show', {
                    text: 'Enviando solicitação',
                    textVisible: true,
                    theme: 'c',
                    html: "<p style=\"text-align:center\">Consultando servidores...</p>"
                });

                mobileUser_Phone = "55,"+$('#ddd').val()+","+$("#phone").val().replace("-","");
                mobileUser_Password = $("#senha").val();
                console.log('step 5')
                var request = $.ajax(serverURL+'/api/MobileUser/Auth/GET?mobileUser_Phone='+ mobileUser_Phone +'&mobileUser_Password=' + mobileUser_Password, {
                    type: 'POST',
                    dataType: 'json',
                    data: {
                        mobileUser_Phone: mobileUser_Phone,
                        mobileUser_Password: mobileUser_Password
                    }
                });

                $.when(request).then(function (data) {
                    console.log(data, "data");
                    if(data == null || (data.error && data.error == true)) {
                        console.log("Login failed");
                        console.log(JSON.stringify(data));
                        if (window.plugins.toast.showShortCenter) {
                            window.plugins.toast.showShortCenter('Usuário e/ou senha inválidos.', function(a){ }, function(b) { });
                            hideloading();
                        }
                    } else {
                        console.log("login success");
                        userData = data;
                        database(sqlCreateUserTable, function(result){
                            if (result.error < 0) {
                                database("SELECT * FROM USER", function(result){
                                    //userData = result.rows[0];
                                    if(result.len > 0){
                                        database('UPDATE USER SET skipped = "0", mobileUser_Phone="'+mobileUser_Phone+'", mobileUser_Password="'+mobileUser_Password+'"', function(result){
                                            logged = true;
                                            $.mobile.changePage("index.html", { transition: "slide" });
                                            hideloading();
                                        });

                                        return;
                                    } else {
                                        database('INSERT INTO USER (skipped,mobileUser_Phone,mobileUser_Password) VALUES ("0","'+mobileUser_Phone+'","'+mobileUser_Password+'")', function(result){
                                            logged = true;
                                            $.mobile.changePage("index.html", { transition: "slide" });
                                            hideloading()
                                        });
                                        return;
                                    }
                                });
                            }
                        });
                    }
                });
                //return request;
            });

        } else if (step == 6) {

             mobileUser_Name = $("input#mobileUser_Name").xval();
             mobileUser_Address = $("input#mobileUser_Address").xval();
             mobileUser_Email = $("input#mobileUser_Email").xval();
             mobileUser_Password = $("input#mobileUser_Password").xval();
             mobileUser_Password_ = $("input#mobileUser_Password_").xval();

             if (mobileUser_Password != mobileUser_Password_ || mobileUser_Password.length < 4) {

                 window.plugins.toast.showShortCenter('As senhas nao conferem.', function(a){ }, function(b) { });
                 return;
             } else if (mobileUser_Email.length < 1) {

                 window.plugins.toast.showShortCenter('E-mail Invalido.', function(a){ }, function(b) { });
                 return;
             }

             userData.mobileUser_Name = mobileUser_Name;
             userData.mobileUser_Address = mobileUser_Address;
             userData.mobileUser_Email = mobileUser_Email;
             userData.mobileUser_Password = mobileUser_Password;

             var request = $.ajax(serverURL+'/api/MobileUser/POST', {
                 type: 'POST',
                 dataType: 'json',
                 data: userData,
                 success: function(ret){
                    userData = ret;

                    $.mobile.changePage(action, { transition: "slide" });
                    //return {status:'success'};
                },
                error: function(ret){
                    window.plugins.toast.showShortCenter('Houve um problema de comunicacao com o servidor, por favor tente mais tarde.', function(a){ }, function(b) { });
                    return false;
                    //return {status:'error'};
                }
             });

        } else if (step == 7) {

            $('#avaliar').addClass("blurBoxes");
            $.mobile.loading( 'show', {
                text: 'Avaliado com sucesso',
                textVisible: true,
                theme: 'c',
                html: "<p style=\"text-align:center\"><img style=\"width: 20px;\" src=\"imgs/star-unique.png\"/></p><p style=\"text-align:center\">Enviando Avaliação!</p>"
            });

            var request = $.ajax(serverURL+'/api/GasStationRating/POST', {
                type: 'POST',
                dataType: 'json',
                data: {
                    mobileUser_Id: userData.mobileUser_Id,
                    gasStation_Id: currentStation.gasStation_Id,
                    gasStation_Rating: currentStation.vote
                }
            });

            $.when(request).then(function (data) {
                if (data && data.gasStation_Id) {
                    originalList=[];
                    currentStation.gasStation_MeanRating.gasStation_RateCount = data.gasStation.gasStation_MeanRating.gasStation_RateCount;
                    currentStation.stars = data.gasStation.gasStation_MeanRating.gasStation_MeanRating;
                    currentStation.gasStation_MeanRating.gasStation_MeanRating = data.gasStation.gasStation_MeanRating.gasStation_MeanRating;
                }
                $.mobile.changePage('detail.html', { transition: 'fade' });
            });

        }  else if (step == 8) {

            $('#denunciar').addClass("blurBoxes");
            $.mobile.loading( 'show', {
                text: 'Enviando denúncia',
                textVisible: true,
                theme: 'c',
                html: "<p style=\"text-align:center\">Enviando denúncia</p>"
            });

            var request = $.ajax(serverURL+'/api/GasStation/Report/POST/', {
                type: 'POST',
                dataType: 'json',
                data: {
                    mobileUser_Id: userData.mobileUser_Id,
                    gasStation_Id: currentStation.gasStation_Id,
                    report_SubSubject: $("#report_SubSubject").val(),
                    report_Subject: $("#report_Subject").val(),
                    report_Message: $("#denuncia").val()
                }
            });

            $.when(request).then(function (data) {

                $.mobile.loading( 'show', {
                    text: 'Denuncia enviada com sucesso',
                    textVisible: true,
                    theme: 'c',
                    html: "<p style=\"text-align:center\">Denúncia enviada<br>com sucesso!</p><a href=\"#\" class=\"bt-epico green radiusTwo \" onclick=\"clickOkReport();\">Ok</a>"
                });

            });

        } else if (step == 9) {

        	$('#edit-veiculo').addClass("blurBoxes");
            $.mobile.loading( 'show', {
                text: 'Enviando dados',
                textVisible: true,
                theme: 'c',
                html: "<p style=\"text-align:center\">Enviando dados</p>"
            });

            userData.mobileUser_FavouriteFuel = $("#mobileUser_FavouriteFuel").val();
            userData.mobileUser_Car = [{

                mobileUserCar_Name : $("input#mobileUserCar_Name").val(),
                mobileUserCar_HasGasoline : Number($("input#mobileUserCar_HasGasoline")[0].checked),
                mobileUserCar_HasAlcohol : Number($("input#mobileUserCar_HasAlcohol")[0].checked),
                mobileUserCar_HasDiesel : Number($("input#mobileUserCar_HasDiesel")[0].checked),
                mobileUserCar_HasCNG : Number($("input#mobileUserCar_HasCNG")[0].checked),

                mobileUserCar_KMLGasoline : $("#mobileUserCar_KMLGasoline").val(),
                mobileUserCar_KMLAlcohol : $("#mobileUserCar_KMLAlcohol").val(),
                mobileUserCar_KMLCNG : $("#mobileUserCar_KMLCNG").val(),
                mobileUserCar_KMLDiesel : $("#mobileUserCar_KMLDiesel").val(),

                mobileUserCar_TankSize : $("#mobileUserCar_TankSize").val(),

        	}];

            var request = $.ajax(serverURL+'/api/MobileUser/POST', {
                type: 'POST',
                dataType: 'json',
                data: userData,
                success: function(ret){
                   userData = ret;
                   $.mobile.changePage(action, { transition: "slide" });
                   originalList=[];
                   //return {status:'success'};
               },
               error: function(ret){
            	   $.mobile.loading('hide');
            	   $.mobile.changePage(action, { transition: "slide" });
                   window.plugins.toast.showShortCenter('Houve um problema de comunicacao com o servidor, por favor tente mais tarde.', function(a){
                	   $('#edit-veiculo').removeClass("blurBoxes");
                   }, function(b) {
                	   $('#edit-veiculo').removeClass("blurBoxes");
                   });
                   return false;
                   //return {status:'error'};
               }
            });

        } else if (step == 10) {

        	$('#recuperar-senha').addClass("blurBoxes");
            $.mobile.loading( 'show', {
                text: 'Enviando solicitação',
                textVisible: true,
                theme: 'c',
                html: "<p style=\"text-align:center\">Consultando servidores...</p>"
            });

            var request = $.ajax(serverURL+'/api/MobileUser/ForgotPassword/POST', {
                type: 'POST',
                dataType: 'json',
                data: {
                	mobileUser_Email: $("#mobileUser_Email").xval()
                }
            });

            $.when(request).then(function (data) {

            	var html = "";

            	if (data.error) {
            		html = "E-mail não cadastrado";
            	} else if (data) {
            		html = "E-mail enviado com sucesso!";
            	}

            	$.mobile.loading( 'show', {
                    text: html,
                    textVisible: true,
                    theme: 'c',
                    html: "<p style=\"text-align:center\">"+html+"</p><a href=\"#\" class=\"bt-epico green radiusTwo \" onclick=\"clickOkSenha();\">Ok</a>"
                });


            });

        } else if (step == 11) {
            $.mobile.changePage(action, { transition: "slide" });
        } else if (step == 12) {

        	var cadastredCarsLength = 0;

            if (userData == undefined) {
                userData = [];
            }

            if (userData.mobileUser_Car == undefined) {
                userData.mobileUser_Car = [];
            }

        	mobileUser_Car = userData.mobileUser_Car;

        	$.each(mobileUser_Car, function(index, value){
        		cadastredCarsLength += 1;
        	});

        	mobileUser_Car[cadastredCarsLength] =
	            {
	                mobileUserCar_Maker: $('#mobileUserCar_Maker').find('option:selected').html(),
	                mobileUserCar_Model: $('#mobileUserCar_Model').find('option:selected').html(),
	                mobileUserCar_Year: $('#mobileUserCar_Year').find('option:selected').html(),
	                mobileUserCar_Name: $('#mobileUserCar_Name').xval(),
	                mobileUserCar_HasGasoline : Number($("input#mobileUserCar_HasGasoline")[0].checked),
	                mobileUserCar_HasAlcohol : Number($("input#mobileUserCar_HasAlcohol")[0].checked),
	                mobileUserCar_HasDiesel : Number($("input#mobileUserCar_HasDiesel")[0].checked),
	                mobileUserCar_HasCNG : Number($("input#mobileUserCar_HasCNG")[0].checked),
	                mobileUserCar_KMLGasoline: Number($('#mobileUserCar_KMLGasoline').xval()),
	                mobileUserCar_KMLDiesel: Number($('#mobileUserCar_KMLDiesel').xval()),
	                mobileUserCar_KMLAlcohol: Number($('#mobileUserCar_KMLAlcohol').xval()),
	                mobileUserCar_KMLCNG: Number($('#mobileUserCar_KMLCNG').xval()),
	                mobileUserCar_TankSize: Number($('#mobileUserCar_TankSize').xval()),
	                mobileUserCar_PrimaryFuel: $('#mobileUser_FavoriteFuel').val()
	            };
        	if (logged) {
        		userData.mobileUser_Car = mobileUser_Car;
        		if (!mobileUser_NewsOptin) {
        			userData.mobileUser_NewsOptin = Number(userData.mobileUser_NewsOptin);
        		}
        		var request = $.ajax(serverURL+'/api/MobileUser/POST', {
                    type: 'POST',
                    dataType: 'json',
                    data: userData,
                    success: function(ret){
                       originalList = [];
                       userData = ret;
                       $.mobile.changePage(action, { transition: "slide" });
                       //return {status:'success'};
                   },
                   error: function(ret){
                       window.plugins.toast.showShortCenter('Houve um problema de comunicacao com o servidor, por favor tente mais tarde.', function(a){ }, function(b) { });
                       return false;
                       //return {status:'error'};
                   }
                });
        	}

            $.mobile.changePage(action, { transition: "slide" });
        } else if (step == 13) {
            console.log("Entered on edit");
            $.mobile.changePage(action, { transition: "slide" });
        } else if (step == 14) {

            cadastredCarsLength = Number($('#indexCar').val());

            if (!mobileUser_NewsOptin) {
                userData.mobileUser_NewsOptin = Number(userData.mobileUser_NewsOptin);
            }
            mobileUser_Car[cadastredCarsLength] =
            {
                mobileUserCar_Maker: $('#mobileUserCar_Maker').find('option:selected').html(),
                mobileUserCar_Model: $('#mobileUserCar_Model').find('option:selected').html(),
                mobileUserCar_Year: $('#mobileUserCar_Year').find('option:selected').html(),
                mobileUserCar_Name: $('#mobileUserCar_Name').xval(),
                mobileUserCar_HasGasoline : Number($("input#mobileUserCar_HasGasoline")[0].checked),
                mobileUserCar_HasAlcohol : Number($("input#mobileUserCar_HasAlcohol")[0].checked),
                mobileUserCar_HasDiesel : Number($("input#mobileUserCar_HasDiesel")[0].checked),
                mobileUserCar_HasCNG : Number($("input#mobileUserCar_HasCNG")[0].checked),
                mobileUserCar_KMLGasoline: Number($('#mobileUserCar_KMLGasoline').xval()),
                mobileUserCar_KMLDiesel: Number($('#mobileUserCar_KMLDiesel').xval()),
                mobileUserCar_KMLAlcohol: Number($('#mobileUserCar_KMLAlcohol').xval()),
                mobileUserCar_KMLCNG: Number($('#mobileUserCar_KMLCNG').xval()),
                mobileUserCar_TankSize: Number($('#mobileUserCar_TankSize').xval()),
                mobileUserCar_PrimaryFuel: $('#mobileUser_FavoriteFuel').val(),
                mobileUserCar_Id: userData.mobileUser_Car[cadastredCarsLength].mobileUserCar_Id
            };

            if (logged) {
                userData.mobileUser_Car = mobileUser_Car;
                var request = $.ajax(serverURL+'/api/MobileUser/POST', {
                    type: 'POST',
                    dataType: 'json',
                    data: userData,
                    success: function(ret){
                       originalList = [];
                       userData = ret;

                       $.mobile.changePage(action, { transition: "slide" });
                       //return {status:'success'};
                   },
                   error: function(ret){
                       window.plugins.toast.showShortCenter('Houve um problema de comunicacao com o servidor, por favor tente mais tarde.', function(a){ }, function(b) { });
                       return false;
                       //return {status:'error'};
                   }
                });
            }

            $.mobile.changePage(action, { transition: "slide" });

        } else if (step == 15) {

            var totalLiters = 0, totalPrice = 0, autonomia = 0;
            $.each(simulation.simulation.fuelHistoryEntry, function(i, item){
                totalPrice += (item.fuelHistory_Price*item.fuelHistory_Quantity);
                totalLiters += item.fuelHistory_Quantity;
            });

            if (totalLiters < 1 ) {
                window.plugins.toast.showShortCenter('Impossível cadastrar abastecimento de 0 litros.', function(a){ }, function(b) { });
                return;
            }

            if (logged) {
                userData.mobileUser_Car = mobileUser_Car;
                var request = $.ajax(serverURL+'/api/MobileUserFuelHistory/POST', {
                    type: 'POST',
                    dataType: 'json',
                    data: simulation.simulation,
                    success: function(ret){
                       $.mobile.changePage(action, { transition: "slide" });
                       //return {status:'success'};
                   },
                   error: function(ret){
                       window.plugins.toast.showShortCenter('Houve um problema de comunicacao com o servidor, por favor tente mais tarde.', function(a){ }, function(b) { });
                       return false;
                       //return {status:'error'};
                   }
                });
            }

            $.mobile.changePage(action, { transition: "slide" });
        } else if (step == 16) {

        	if ($("#gasStation_Name").val().length < 3) {
        		window.plugins.toast.showShortCenter('Insira corretamente um nome para o posto.', function(a){ }, function(b) { });
        		return;
            }


			mobileUserCar_HasGasoline = Number($("input#mobileUserCar_HasGasoline")[0].checked);
            mobileUserCar_HasAlcohol = Number($("input#mobileUserCar_HasAlcohol")[0].checked);
            mobileUserCar_HasDiesel = Number($("input#mobileUserCar_HasDiesel")[0].checked);
            mobileUserCar_HasCNG = Number($("input#mobileUserCar_HasCNG")[0].checked);
            mobileUserCar_KMLGasoline = Number($('#mobileUserCar_KMLGasoline').xval());
            mobileUserCar_KMLDiesel = Number($('#mobileUserCar_KMLDiesel').xval());
            mobileUserCar_KMLAlcohol = Number($('#mobileUserCar_KMLAlcohol').xval());
            mobileUserCar_KMLCNG = Number($('#mobileUserCar_KMLCNG').xval());

            if (mobileUserCar_KMLGasoline == 0 && mobileUserCar_KMLDiesel == 0 && mobileUserCar_KMLAlcohol == 0  && mobileUserCar_KMLCNG == 0) {
        		window.plugins.toast.showShortCenter('Ao menos um combustível com preço é obrigatório.', function(a){ }, function(b) { });
        		return;
            }

            novo_posto = {
            		gasStation_Address: novo_posto.gasStation_Address,
            		gasStation_Latitude: novo_posto.gasStation_Latitude,
            		gasStation_Longitude : novo_posto.gasStation_Longitude,
            		gasStation_Name : $("#gasStation_Name").val(),
        			gasStation_Flag : $("#gasStation_Flag").val(),
        			gasStation_Price : [
        			                    {
        			                    	gasStationPoolPrice_Price: mobileUserCar_KMLGasoline,
        			                    	gasStationPoolPrice_Fuel: "gasoline"
        			                    },
        			                    {
        			                    	gasStationPoolPrice_Price: mobileUserCar_KMLDiesel,
        			                    	gasStationPoolPrice_Fuel: "alcohol"
        			                    },
        			                    {
        			                    	gasStationPoolPrice_Price: mobileUserCar_KMLDiesel,
        			                    	gasStationPoolPrice_Fuel: "diesel"
        			                    },
        			                    {
        			                    	gasStationPoolPrice_Price: mobileUserCar_KMLCNG,
        			                    	gasStationPoolPrice_Fuel: "cng"
        			                    }
        			                    ],
        	}

            if (logged) {

            	$('.ui-page-active').addClass("blurBoxes");
            	$.mobile.loading( 'show', {
                    text: 'Enviando solicitação',
                    textVisible: true,
                    theme: 'c',
                    html: "<p style=\"text-align:center\">Obrigado pela sua contribuição. O posto estará disponível em breve para toda a comunidade Proteste Postos.<a href=\"#\" class=\"bt-epico green radiusTwo \" onclick=\"hideloading('"+action+"');\">Ok</a></p>"
                });

                var request = $.ajax(serverURL+'/api/GasStation/SugestGasStation/POST', {
                    type: 'POST',
                    dataType: 'json',
                    data: novo_posto,
                    success: function(ret){
                        console.log("Success: >>>>>>>>>>>>>>", ret);
                   },
                   error: function(ret){
                	   hideloading();
                       window.plugins.toast.showShortCenter('Houve um problema de comunicacao com o servidor, por favor tente mais tarde.', function(a){ }, function(b) { });
                       console.log("Error: >>>>>>>>>>>>>>", ret);
                       console.log(JSON.stringify(ret));
                       console.log(JSON.stringify(novo_posto));
                       return false;
                   }
                });
            }

            //$.mobile.changePage(action, { transition: "slide" });
        }

    }

    return;

}

var sending = false;
function insertUserBackEnd(action) {
	if (!sending) {

		sending = true;

	    database(sqlCreateUserTable, function(result){
	        if (result.error < 0) {
	            database("SELECT * FROM USER", function(result){
	                if(result.len > 0){
	                    database('DROP TABLE USER', function(result){
	                        // CALLBACK

	                    });
	                    hideloading();
	                    return;
	                }
	            });
	        }
	    });

	    var request = $.ajax(serverURL+'/api/MobileUser/POST', {
	        type: 'POST',
	        dataType: 'json',
	        data: {
	            mobileUser_Name: mobileUser_Name,
	            mobileUser_Email: mobileUser_Email,
	            mobileUser_Phone: mobileUser_Phone,
	            mobileUser_Password: mobileUser_Password,
	            mobileUser_Address: mobileUser_Address,
	            mobileUser_NewsOptin: Number(mobileUser_NewsOptin),
	            mobileUser_FavouriteFuel: mobileUser_FavouriteFuel,
	            mobileUser_Car: mobileUser_Car
	        },
	        success: function(ret){

	        	sending = false;

	        	if(ret.errorCode == "MOBILE_USER_PHONE_ALREADY_EXISTS"){

	        		window.plugins.toast.showShortCenter('Usuario ja cadastrado, por favor informe sua senha.',  function(a){ }, function(b) { });
	        		hideloading();
	        		$.mobile.changePage("login.html", { transition: "fade" });
	        		return;

	        	} else {

	        		userData = ret;

	        		if(userData == null) {
	                    if (window.plugins.toast.showShortCenter) {
	                        window.plugins.toast.showShortCenter('Usuário e/ou senha inválidos.', function(a){ }, function(b) { });
	                        hideloading();
	                    }
	                } else {
	                    database(sqlCreateUserTable, function(result){
	                        if (result.error < 0) {
	                            database("SELECT * FROM USER", function(result){
	                                //userData = result.rows[0];
	                                if(result.len > 0){
	                                    database('UPDATE USER SET skipped = "0", mobileUser_Phone="'+mobileUser_Phone+'", mobileUser_Password="'+mobileUser_Password+'"', function(result){
	                                    	logged = true;
	                                        $.mobile.changePage(action, { transition: "slide" });
	                                    });
	                                    hideloading();
	                                    return;
	                                } else {
	                                    database('INSERT INTO USER (skipped,mobileUser_Phone,mobileUser_Password) VALUES ("0","'+mobileUser_Phone+'","'+mobileUser_Password+'")', function(result){
	                                    	logged = true;
	                                        $.mobile.changePage(action, { transition: "slide" });
	                                    });
	                                    hideloading();
	                                    return;
	                                }
	                            });
	                        }
	                    });
	                }



		        	//$.mobile.changePage(action, { transition: "slide" });
					//return {status:'success'};

	        	}

			},
			error: function(ret){
				sending = false;
				window.plugins.toast.showShortCenter('Houve um problema de comunicacao com o servidor, por favor tente mais tarde.',  function(a){ }, function(b) { });
				hideloading();
				return;
				//return {status:'error'};
			}
	    });

	}

}

function encode_utf8(s) {
	return unescape(encodeURIComponent(s));
}

function decode_utf8(s) {
	return decodeURIComponent(escape(s));
}

function replaceNavigator(origNavigator) {
    var CordovaNavigator = function() {};
    CordovaNavigator.prototype = origNavigator;
    var newNavigator = new CordovaNavigator();
    // This work-around really only applies to new APIs that are newer than Function.bind.
    // Without it, APIs such as getGamepads() break.
    if (CordovaNavigator.bind) {
        for (var key in origNavigator) {
            if (typeof origNavigator[key] == 'function') {
                newNavigator[key] = origNavigator[key].bind(origNavigator);
            } else {
                (function(k) {
                    Object.defineProperty(newNavigator, k, {
                        get: function() {
                            return origNavigator[k];
                        },
                        configurable: true,
                        enumerable: true
                    });
                })(key);
            }
        }
    }
    return newNavigator;
}



function clickOkRating() {
    $.mobile.loading('hide');
    $('#avaliar').removeClass("blurBoxes");
    $.mobile.changePage('detail.html', { transition: 'fade' });
}

function clickOkReport() {

    originalList = [];

    $.mobile.loading('hide');
    $('#denunciar').removeClass('blurBoxes');
    $.mobile.changePage('detail.html', { transition: 'fade' });

}

function clickOkSenha() {

    originalList = [];

    $.mobile.loading('hide');
    $('#recuperar-senha').removeClass('blurBoxes');
    $.mobile.changePage('login.html', { transition: 'fade' });

}

function hideloading(action) {
	if (action && action.length > 0) {
		$.mobile.changePage(action, { transition: "slide" });
	}

	$.mobile.loading('hide');
 	$('.ui-page-active').removeClass("blurBoxes");
}
